# Contributing

Documentation is generated using [mkdocs][mkdocs] and deployed on
[Drupal's GitLab instance][drupal-gitlab] using [GitLab Pages][gitlab-pages].

## Local development

If you do not already have it installed, install [pip][python-pip].

Execute the following commands to install pip packages, build the documentation,
and serve it on localhost:

```shell
pip install mkdocs # mkdocs-material mkdocs-glightbox mkdocs-awesome-pages-plugin
mkdocs build
mkdocs serve
```

The final command should generate output like this:

```text
INFO    -  Building documentation...
INFO    -  Cleaning site directory
INFO    -  Documentation built in 0.14 seconds
INFO    -  [11:44:05] Watching paths for changes: 'docs', 'mkdocs.yml'
INFO    -  [11:44:05] Serving on http://127.0.0.1:8000/member/
```

Go to the link it provides and you should see the documentation. When you make
changes, it should automatically rebuild and refresh the page in your browser:

```text
INFO    -  [11:46:56] Detected file changes
INFO    -  Building documentation...
INFO    -  Documentation built in 0.13 seconds
INFO    -  [11:46:56] Reloading browsers
INFO    -  [11:46:56] Browser connected: http://127.0.0.1:8000/member/
```

[drupal-gitlab]: https://drupalcode.org

[gitlab-pages]: https://docs.gitlab.com/user/project/pages/

[mkdocs]: https://www.mkdocs.org/

[python-pip]: https://pypi.org/project/pip/
