# Glossary

## Current terminology

### Install profile

A drupal extension that can contain modules, themes, configuration, content and
describes how to install a site.

### Distribution

A special form of install profile which selects itself when uniquely available
in the installer. Users of distributions expect upgrades to future versions and
some level of support.

### Starter kit

A special form of install profile (for example Contenta or Foundry) that
provides a place to start with no upgrade path for the starter kit. For an early
usage of this terminology with respect to install profiles see
this [video](https://archive.org/details/DrupalconSf2010DrupalDistributionsOnDrupal.org) (
around 16:50).

### Project

A drupal.org / composer packagist concept. Can be a single module or a group of
modules. For
example: [Access Unpublished](https://www.drupal.org/project/access_unpublished)
is a single module and [Devel](https://www.drupal.org/project/devel) contains a
group of modules. On drupal.org an install profile is also a project. Note: we
often refer to modules that are not the same as the project name as submodules
but in the Drupal extension system and composer ecosystem the concept of
submodules has little meaning. The Drupal extensions considers all modules
equally and Composer has no knowledge of modules and only knows about projects.
The Update module in core is project-aware.

### Module

Provides functionality and configuration in a single extension.

### Theme

An extension that defines the visual look and feel of your site.

### Starterkit theme

A tool for generating Drupal themes with default markup that is maintained in
core.

### Feature

A special type of module comprised of different site building components built
using the [Features](https://www.drupal.org/project/features) module.

### Tours

A tour walks users through how to configure and use Drupal. They are
configuration entities provided by modules and install profiles.

### Composer project template

A [composer.json that via composer create-project](composer_project_template.md)
supplies a starting point for a Drupal site. As part of the initiative these
will get new capabilities to replace some of what install profiles (especially
distributions) can do today.

## New terminology

### Drupal recipe

[Drupal recipes](recipe.md) allow the automation of Drupal module install and
configuration via the user interface and via the Drupal recipe runner.
