# Drupal recipe roadmap

## Phase 1

Main aim: to create the ability to apply an arbitrary recipe to a Drupal site

### Done
* [#3427558](https://www.drupal.org/project/distributions_recipes/issues/3427558)
  Output information from the recipe application process
* [#3292275](https://www.drupal.org/project/distributions_recipes/issues/3292275)
  Recipe class to read recipe.yml and composer.json
* [#3292281](https://www.drupal.org/project/distributions_recipes/issues/3292281#comment-14582069)
  Create recipe runner to process drupal-recipe recipe.yml files to
  install listed drupal extensions without their configuration entities
* [#3292282](https://www.drupal.org/project/distributions_recipes/issues/3292282)
  Extend recipe runner to create configuration provided in the recipe's
  /config folder
* [#3292284](https://www.drupal.org/project/distributions_recipes/issues/3292284)
  Extend recipe runner to allow recipe.yml to select configuration from
  installed modules
* [#3297426](https://www.drupal.org/project/distributions_recipes/issues/3297426)
  Enable a recipe to apply other recipes prior to by applied itself
* [#3284025](https://www.drupal.org/project/distributions_recipes/issues/3284025)
  Add configuration actions API
* [#3292285](https://www.drupal.org/project/distributions_recipes/issues/3292285)
  Add the ability to define configuration actions in recipes
* [#3292287](https://www.drupal.org/project/distributions_recipes/issues/3292287)
  Extend recipe runner to create content provided in the recipe's /content
  folder

## Phase 2

Main aim: to refine and improve the recipe system to be used in Starshot.

* Starshot blockers
* Add a core/core.recipes.api.php file
* Help end users find recipes on Drupal.org, in Project browser and the installer
* Improve the recipe application process
* Create config check points and allow recipes to be reverted
* Unpack Recipes using Composer
* Make recipes work with composer better
* Add and improve config actions
* Fix bugs
* Validate recipes and configuration
* Add additional core recipes 

### To Do
* [#3446089](https://www.drupal.org/project/distributions_recipes/issues/3446089) Recipes Phase 2 Roadmap

## Phase 3

Main aim: to integrate create tools for recipe creation.

TBD, includes:

* UI tools for recipe creation
* CLI tools for recipe creation

